// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel.feature.person;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Personne liés à une usager. Par exemple, un capitaine (patron) de navire, un marin, etc.
 * ref : flux SACAPT, SIH-INRH
 * ATTENTION :
 * - Pour Ifremer, actuellement non utilisée, pour observation de la données SACAPT avant
 * utilisation. Pour le moment, la donnée est stockée dans 'Playground'.
 * @see VesselPerson
 */
public interface VesselPersonDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link VesselPerson}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of VesselPerson from the persistent store.
     * @param id
     * @return VesselPerson
     */
    public VesselPerson get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of VesselPerson from the persistent store.
     * @param id
     * @return VesselPerson
     */
    public VesselPerson load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link VesselPerson}.
     *
     * @return the loaded entities.
     */
    public Collection<VesselPerson> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of VesselPerson and adds it to the persistent store.
     * @param vesselPerson
     * @return VesselPerson
     */
    public VesselPerson create(VesselPerson vesselPerson);

    /**
     * <p>
     * Does the same thing as {@link #create(VesselPerson)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param vesselPerson
     * @return Object
     */
    public Object create(int transform, VesselPerson vesselPerson);

    /**
     * Creates a new instance of VesselPerson and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of VesselPerson
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<VesselPerson> create(Collection<VesselPerson> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(VesselPerson)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<VesselPerson> entities);

    /**
     * <p>
     * Creates a new <code>VesselPerson</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param registrationCode Code d'enregistrament du patron pecheur.
Code unique si donnée SACAPT (DPMA)
     * @param lastname Nom du patron de peche
     * @param firstname Prénom du patron de peche
     * @param street Rue de l'habitation du patron de peche
     * @param zipCode Code postal du patron
     * @param city Ville du patron
     * @param address Adresse du patron (calculé à partir de street, zipCode et city)
     * @param dateOfBirth Date de naissance du patron.
     * @param retirementDate Date du dernier jour d'activité (retraite)
     * @param isInRetirement Le patron est il en retraite, à la date du système (calculé à partir de la date retirementDate)
     * @param phoneNumber 
     * @param mobileNumber 
     * @param faxNumber 
     * @param email 
     * @param updateDate 
     * @param remoteId 
     * @return VesselPerson
     */
    public VesselPerson create(
        String registrationCode,
        String lastname,
        String firstname,
        String street,
        String zipCode,
        String city,
        String address,
        Date dateOfBirth,
        Date retirementDate,
        Boolean isInRetirement,
        String phoneNumber,
        String mobileNumber,
        String faxNumber,
        String email,
        Timestamp updateDate,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, String, String, String, String, Date, Date, Boolean, String, String, String, String, Timestamp, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param registrationCode Code d'enregistrament du patron pecheur.
Code unique si donnée SACAPT (DPMA)
     * @param lastname Nom du patron de peche
     * @param firstname Prénom du patron de peche
     * @param street Rue de l'habitation du patron de peche
     * @param zipCode Code postal du patron
     * @param city Ville du patron
     * @param address Adresse du patron (calculé à partir de street, zipCode et city)
     * @param dateOfBirth Date de naissance du patron.
     * @param retirementDate Date du dernier jour d'activité (retraite)
     * @param isInRetirement Le patron est il en retraite, à la date du système (calculé à partir de la date retirementDate)
     * @param phoneNumber 
     * @param mobileNumber 
     * @param faxNumber 
     * @param email 
     * @param updateDate 
     * @param remoteId 
     * @return VesselPerson
     */
    public Object create(
        int transform,
        String registrationCode,
        String lastname,
        String firstname,
        String street,
        String zipCode,
        String city,
        String address,
        Date dateOfBirth,
        Date retirementDate,
        Boolean isInRetirement,
        String phoneNumber,
        String mobileNumber,
        String faxNumber,
        String email,
        Timestamp updateDate,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>VesselPerson</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param program
     * @return VesselPerson
     */
    public VesselPerson create(
        Program program);

    /**
     * <p>
     * Does the same thing as {@link #create()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param program
     * @return Object
     */
    public Object create(
        int transform,
        Program program);

    /**
     * Updates the <code>vesselPerson</code> instance in the persistent store.
     * @param vesselPerson
     */
    public void update(VesselPerson vesselPerson);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<VesselPerson> entities);

    /**
     * Removes the instance of VesselPerson from the persistent store.
     * @param vesselPerson
     */
    public void remove(VesselPerson vesselPerson);

    /**
     * Removes the instance of VesselPerson having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<VesselPerson> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<VesselPerson> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final VesselPerson entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,VesselPerson)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,VesselPerson)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}